#include "solvepqrs.h"
#include "fourth.h"

int32 *a;
GEN *pa;
int32 *b;
GEN *qb;
int32 *c;
GEN *rc;
int32 *d;
GEN *sd;

main(argc,argv)
int argc;
char **argv;
{
  int n, intprec;
  long ltop;

  pari_init(20000000, 97);

  fourthargs(argv,argc,1,2,3,4,5);

  fourth(&a,&pa,p);
  fourth(&b,&qb,q);
  fourth(&c,&rc,r);
  fourth(&d,&sd,s);

  ltop = avma;
  intprec = lgefint(addii(pa[len-1], qb[len-1]));
  n = lgefint(addii(rc[len-1], sd[len-1]));
  if(n > intprec) intprec = n;
  avma = ltop;

  if (solvepqrs(len,a,pa,len,b,qb,len,c,rc,len,d,sd,gun,intprec,
		fourthsoln) == -1) nomem();

  exit(0);
}
